
"""
Name: 'ZweisteinExporter3.0'
Blender: 245
Group: 'Export'
Tip: 'Export to ZMS (Zweistein-Model-Static)'
"""

# PRESS ALT+P TO EXPORT YOUR MESHES

import math, string
import Blender
from Blender import Texture
from Blender import Material

myFilename	=	Blender.Get("filename")

file		=	open(myFilename + ".zms", "w")
print "\n\nsaved as: ";
print myFilename + ".zmd";



#file.write("/* 	Exporter by Zweistein	*/\n");

scene		=	Blender.Scene.GetCurrent();

objects		=	scene.getChildren();



if objects[0].getType() == "Mesh":
		
	#file.write("/*Model: " + objects[0].getName() + "*/\n")
	#file.write("/*Type: " + objects[0].getType() + "*/\n/* */\n")
	
	myMesh		=	objects[0].getData();

	anzahlverts	=	len(myMesh.verts);
	anzahlfaces	=	len(myMesh.faces);
	hasUV		=	myMesh.hasFaceUV();
	
	hasMaterials	=	0;
	if len(Material.Get()) > 0:
		hasMaterials	=	len(Material.Get()) / len(Material.Get());
	
		
	#file.write("/*Generalinfo: (hasMaterials, anzahlverts, anzahlfaces, hasUV, UVTexture) */");
	uvfilefinal = "";
	if hasUV:
		for o in range(len(myMesh.faces)):
			uvfile	 = str(myMesh.faces[o].image).split(None,1)[-1][1:-2]
			if (uvfile != "o"):
				if (uvfile != ""):
					uvfilefinal = "resources/textures/" + uvfile;	
		
	file.write("%i %i %i %i %s" % (hasMaterials, anzahlverts, anzahlfaces, hasUV, uvfilefinal))
		
	#file.write("\n/*Materialinfo: (r,g,b,hard,spec,envmap,envstatic) */\n");		

	if hasMaterials:
		m = Material.Get()
			
		mat_r		=	m[0].R
		mat_g		=	m[0].G
		mat_b		=	m[0].B
		hard		=	m[0].hard
		spec		=	m[0].spec

		#file.write("\n/*Material: */\n");
		file.write("\n%1.7f %1.7f %1.7f %2.6f %1.7f" % (mat_r, mat_g, mat_b, hard, spec))
		#file.write("/*Material End:  */");			


	#file.write("/*Vertexinfo: (normal.x, normal.y, normal.z, pos.x, pos.y, pos.z) */\n");
	for v in myMesh.verts:
		file.write("\n");		
		#file.write("%i " % v.index)

		file.write("%3.6f " % myMesh.verts[v.index].no[0] )
		file.write("%3.6f " % myMesh.verts[v.index].no[1] )
		file.write("%3.6f " % myMesh.verts[v.index].no[2] )
		
		file.write("%3.6f " % myMesh.verts[v.index].co[0] )
		file.write("%3.6f " % myMesh.verts[v.index].co[1] )
		file.write("%3.6f " % myMesh.verts[v.index].co[2] )

	#file.write("/*Faceinfo: (facesmooth, normal.x, normal.y, normal.z, vertCount, { VertexIDs[x] { u, v} } , facematerial  ) */\n");
	
	for v in range(len(myMesh.faces)):	
		file.write("\n");
		
		file.write("%i " % myMesh.faces[v].smooth)
		matindex = myMesh.faces[v].materialIndex
		materiallist = myMesh.getMaterials(-1);
		hasmaterial = 0
			
		file.write("%3.6f " % myMesh.faces[v].normal[0])
		file.write("%3.6f " % myMesh.faces[v].normal[1])
		file.write("%3.6f " % myMesh.faces[v].normal[2])

		file.write("%i " % len(myMesh.faces[v]));

		for w in range(len(myMesh.faces[v])):

			myFace	=	myMesh.faces[v].v[w].index;			
			file.write("%i " % myFace )
			
			if hasUV:
				g = w - 1;
				if g == -1:
					g == len(myMesh.faces[v]);
				if g == -2:
					g == len(myMesh.faces[v])-1;
				file.write("%3.6f " % myMesh.faces[v].uv[w][0])
				file.write("%3.6f " % myMesh.faces[v].uv[w][1])
			
		#file.write("n")
		
print "exporting maybe succesfull with Zweistein Exporter :)"
