/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 2.1.2008
 *
 * The Audio Module.
 */
module auio;

import derelict.sdl.mixer;
import derelict.sdl.sdl;
import singleton;
import task;
import config;

class Audio : Task {
public:
    mixin Singleton;
    override void init() {
		if(SDL_WasInit(SDL_INIT_AUDIO)==0)
            if (SDL_Init(SDL_INIT_AUDIO) != 0)
                throw new Exception(__FILE__ ~ ": Could not init Audio Mode. Error in SDL_Init().");
    	if (Mix_OpenAudio(Config["audio_frequency"], MIX_DEFAULT_FORMAT, Config["audio_channels"], Config["audio_chunksize"]) != 0)
			throw new Exception(__FILE__ ~ ": Could not init Audio Mode. Error in Mix_OpenAudio().");
		Mix_AllocateChannels(16);
		Mix_Volume(1,MIX_MAX_VOLUME/2);
    }
    override int refresh()  {
		return 0;
    };
    override void uninit() {
    	Mix_CloseAudio();
	};
}
