/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 17.1.2008
 *
 * DEngine: The DEngine loop, which provides some useful services
 */
module dengine;

import task;
import config;
import window, input, renderer, timer, audio;

class DEngine : Task {
    void init()     {
        Config.load("resources/config.cfg");

        myTasks ~= Window.getInstance();
        myTasks ~= Input.getInstance();
        myTasks ~= Renderer.getInstance();
        myTasks ~= Audio.getInstance();
        myTasks ~= Timer.getInstance();
        foreach(t; myTasks) t.init();
    };
    void uninit()   {
        foreach(t; myTasks) {
            t.uninit();
            delete t;
        };
        myTasks.length = 0;

        Config.unload();
    };
    int refresh()  {
        foreach(t; myTasks) t.refresh();
        return 0;
    };

private:
    Task[]  myTasks;
};
