/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 6.1.2008
 *
 * The Loader class. It just displays the Loading screen while Loading.
 */
module loader;

import derelict.opengl.gl;
import resourcemanager;
import texture2d;
import unit;
import config;
import singleton;
import window;
import renderer;

import std.date;
import std.stdio;

class Loader : Unit {
public:
    mixin Singleton;
    static void display() {
        Loader.getInstance.init();
        Renderer.getInstance().join2D();
        Loader.getInstance.refresh();
        Window.getInstance.refresh();
        Loader.getInstance.uninit();
    };
    void init() {
			myTexture = cast(Texture2D)ResourceManager.getInstance.need(Texture2D.classinfo, "resources/textures/loading.png");
    	};
    void refresh() {
        glBindTexture(GL_TEXTURE_2D, myTexture.texture);
        glBegin(GL_QUADS);
            glTexCoord2f(0,1); glVertex2f( 0,                       0);
            glTexCoord2f(1,1); glVertex2f(Config["renderer_width"], 0);
            glTexCoord2f(1,0); glVertex2f(Config["renderer_width"], Config["renderer_height"]);
            glTexCoord2f(0,0); glVertex2f( 0,                       Config["renderer_height"]);
        glEnd();
    };
    void uninit() { ResourceManager.getInstance.unNeed(myTexture); };

private:
    Texture2D myTexture;
};
