/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 11.1.2008
 *
 * This is the Copyright Menue!
 */
module menuecopyright;

import menueimpl;
import fontwriter;
alias fontwriter.FontWriter.getInstance FontWriter;
import button;
import config;
import point;

class MenueCopyright : MenueImpl {
public:

    override void init(Menue theMenue) {
        myButtons.length = 3;

        myButtons[0]    =   new Button;
        myButtons[0].init(Point2D(Config["window_width"]-250, 220), Point2D(256,37),".start game", "resources/sounds/menue_click.wav", "resources/sounds/menue_over.wav");
        myButtons[0].addActionListener(theMenue, "Menue", "LVL");

        myButtons[1]    =   new Button;
        myButtons[1].init(Point2D(Config["window_width"]-250, 170), Point2D(256,37),".copyrights", "resources/sounds/menue_click.wav", "resources/sounds/menue_over.wav");
        myButtons[1].addActionListener(theMenue, "Menue", "Copyright");

        myButtons[2]    =   new Button;
        myButtons[2].init(Point2D(Config["window_width"]-250, 120), Point2D(256,37),".quit game", "resources/sounds/menue_click.wav", "resources/sounds/menue_over.wav");
        myButtons[2].addActionListener(theMenue, "Menue", "Quit");
    };

    override void refresh() {
        foreach(button; myButtons) button.refresh();

        FontWriter.Size(3);
        FontWriter.write2D("the Copyrights", 100, Config["window_height"]-120);

        FontWriter.Size(2);
        FontWriter.write2D("Everything done by Matthias Thurau.", 100, Config["window_height"]-200);
        FontWriter.write2D("Visit www.whosme.de for more information.", 100, Config["window_height"]-220);
        FontWriter.write2D("Greetings to Michaela Adam.", 100, Config["window_height"]-240);
        FontWriter.write2D("Copyright by Matthias Thurau, 2008.", 100, Config["window_height"]-260);

        FontWriter.write2D("Comments to Matthiasth@gmx.de.", 100, Config["window_height"]-300);
    };

    override void uninit() {
        foreach(button; myButtons) {
            button.uninit();
            delete button;
        };
    };

private:
    Button[]        myButtons;
};


