/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 18.1.2008
 *
 * ActionListener objects are used to communicate from Menue to the Application.
 */
module menueitem;

import actionlistener;
import point;
import texture2d;
import boundingbox;

import resourcemanager;

class MenueItem {
public:
    void init(Point2D thePosition, Point2D theDimension) {
        myPosition  = thePosition;
        myDimension = theDimension;
        myBB2D      = new BoundingBox2D(Point2D(myPosition.x,myPosition.x+myDimension.x), Point2D(myPosition.y+myDimension.y,myPosition.y));
        myTexture   = cast(Texture2D)ResourceManager.getInstance().need((Texture2D.classinfo), "resources/textures/gui.png");
    };
    void refresh() {};
    void uninit() {
        delete myBB2D;
        ResourceManager.getInstance().unNeed(myTexture);
    };
    void addActionListener(ActionListener al, char[] theCommand, char[] theAttribute) {
        myActionListener    = al;
        command             = theCommand;
        attribute           = theAttribute;
    };

    Point2D position() { return myPosition; };
    Point2D dimension() { return myDimension; };

protected:
    ActionListener   myActionListener;
    char[]           command;
    char[]           attribute;
    Point2D          myPosition;
    Point2D          myDimension;
    BoundingBox2D    myBB2D;
    Texture2D        myTexture;
};
