/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 11.1.2008
 *
 * This is the Silver Winning Menue!
 */
module menuewonsilver;

import menueimpl;
import fontwriter;
alias fontwriter.FontWriter.getInstance FontWriter;
import button;
import config;
import point;
import resourcemanager;
import sound;
import derelict.sdl.mixer;

class MenueWonSilver : MenueImpl {
public:
    override void init(Menue theMenue) {
        mySound   	= cast(Sound)ResourceManager.getInstance().need((Sound.classinfo), "resources/sounds/game_end.wav");
		Mix_PlayChannel(-1, mySound.sound, 0);

        myButtons.length = 3;

        myButtons[0]    =   new Button;
        myButtons[0].init(Point2D(Config["window_width"]-250, 220), Point2D(256,37),".start game", "resources/sounds/menue_click.wav", "resources/sounds/menue_over.wav");
        myButtons[0].addActionListener(theMenue, "Menue", "LVL");

        myButtons[1]    =   new Button;
        myButtons[1].init(Point2D(Config["window_width"]-250, 170), Point2D(256,37),".copyrights", "resources/sounds/menue_click.wav", "resources/sounds/menue_over.wav");
        myButtons[1].addActionListener(theMenue, "Menue", "Copyright");

        myButtons[2]    =   new Button;
        myButtons[2].init(Point2D(Config["window_width"]-250, 120), Point2D(256,37),".quit game", "resources/sounds/menue_click.wav", "resources/sounds/menue_over.wav");
        myButtons[2].addActionListener(theMenue, "Menue", "Quit");
    };
    override void refresh() {
        foreach(button; myButtons) button.refresh();

        FontWriter.Size(3);
        FontWriter.write2D("You have won Silver!", Config["window_width"]/2-100, Config["window_height"]/2+10);
        FontWriter.write2D("Not bad! Not bad!", Config["window_width"]/2-100, Config["window_height"]/2-10);
    };
    override void uninit() {
        foreach(button; myButtons) {
            button.uninit();
            delete button;
        };
        ResourceManager.getInstance().unNeed(mySound);
    };
private:
    Button[]   	myButtons;
    Sound		mySound;
};

