/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 17.1.2007
 *
 * This is the interface, that each Resource can use.
 */
module resource;

import std.stdio;
import resourcemanager;

class Resource {
public:
    void load(char[] theFilename) {
        try loadSpecific(theFilename);
        catch(Exception e) {
            writefln(e.msg);
            writefln("Loading standardfile instead...");
            loadDefault();
        };
    };
    void unload() {
        unloadSpecific();
    };
    void loadSpecific(char[] theFilename) {};
    void loadDefault() {};
    void unloadSpecific() {};

    char[]  filename() { return myFilename; };
    int     listener = 1;
protected:
    char[]  myFilename;
};

class UnloadableResourceException : Exception {
public:
    this(char[] string) {
        super(string);
    };
};
