/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 17.1.2008
 *
 * Singleton: Its a template to use in a Class with a mixin. There can only be one instance of a singleton class.
 */
module singleon;

template Singleton() {
    public static typeof(this) getInstance() {
        if (_instance is null)  _instance   =   new typeof(this)();
        return _instance;
    };
    private static typeof(this) _instance;
};
