/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 17.1.2007
 *
 * This is sound Resource: It can load wav, ogg, ...
 */
module sound;

import derelict.sdl.mixer;

import resource;

class Sound : Resource {

public:
    override void loadSpecific(char[] theFilename) {
        myFilename      =   theFilename;
        mySound			=	Mix_LoadWAV(theFilename);
		if(!mySound) {
			throw new UnloadableResourceException(__FILE__ ~ ": Cannot load Resource " ~ theFilename);
		};
    };
    override void unloadSpecific() {
    	Mix_FreeChunk(mySound);
		mySound	=	null;
    };
    override void loadDefault() {
        loadSpecific("resources/sounds/defaultsound.wav");
    };

    Mix_Chunk* sound() { return mySound; };
private:
	Mix_Chunk *mySound;
};
