/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 17.1.2007
 *
 * This is the Texture2D Resource
 */
module texture2d;

import derelict.opengl.gl;

import resourcemanager;
import resource;
import image;

class Texture2D : Resource {
public:
    override void loadSpecific(char[] theFilename) {
        myFilename     = theFilename;
        Image texImage = cast(Image)ResourceManager.getInstance.need(Image.classinfo, theFilename);
        if (texImage.filename != theFilename) myFilename = texImage.filename;

        glGenTextures(1, &myTexture);
        glBindTexture(GL_TEXTURE_2D, myTexture);
        glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glTexImage2D(GL_TEXTURE_2D, 0, texImage.iformat, texImage.width, texImage.height, 0, texImage.format, GL_UNSIGNED_BYTE, texImage.surface.pixels);
        ResourceManager.getInstance.unNeed(texImage);
    };
    override void unloadSpecific() {
        if (myTexture) glDeleteTextures(1, &myTexture);
    };
    uint texture() { return myTexture; };
private:
    uint myTexture;
};
