/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 2.1.2008
 *
 * The Timer Module refreshes the timer and ticks with SDL_GetTicks();
 */
module timer;

import derelict.sdl.sdl;
import singleton;
import task;

class Timer : Task {
public:
    mixin Singleton;
    override void init() {
        myLastframe   =   SDL_GetTicks();
        myThisframe   =   SDL_GetTicks();
        myTicks       =   0;
    }
    override int refresh() {
        myTicks       = SDL_GetTicks() - myThisframe;
        myThisframe   = SDL_GetTicks();
        myFramescounter++;
        if((myThisframe - myLastframe) > 1000) {
            myFps = myFramescounter;
            myFramescounter = 0;
            myLastframe = myThisframe;
        };
        return 0;
    };
    override void uninit() {
    };
    uint fps()   { return myFps;	};
    uint ticks() { return cast(uint)(cast(float)myTicks/1.0f); 	};
private:
    uint    myFps;
    uint    myTicks;
    uint    myFramescounter;
    uint    myLastframe;
    uint    myThisframe;
}
