/**
 * Authors: Matthias Thurau, whosme.de
 * Date: 2.1.2008
 *
 * The Window Module creates a Window with the help of SDL.
 */
module window;

import derelict.sdl.sdl;
import singleton;
import task;
import config;

class Window : Task {
public:
    mixin Singleton;
    override void init() {
        if(SDL_WasInit(SDL_INIT_VIDEO)==0)
            if (SDL_Init(SDL_INIT_VIDEO) != 0)
                throw new Exception(__FILE__ ~ ": Could not init Video Mode. Error in SDL_Init().");
        if (SDL_SetVideoMode(Config["window_width"], Config["window_height"], 0, SDL_OPENGL | SDL_GL_DOUBLEBUFFER | SDL_FULLSCREEN * Config["fullscreen"]) is null)
            throw new Exception(__FILE__ ~ ": Could not Set Video Mode. Error in SDL_SetVideoMode().");
		SDL_WM_SetCaption( "DEngine", "DEngine" );
    }
    override int refresh()  {
        SDL_GL_SwapBuffers();
        return 0;
    };
    override void uninit() { SDL_Quit(); };
}
